import type { Store } from '@core/store';
import type { StoreScope } from '@core/storeScope';
import type { Context, ReactNode } from 'react';
export type StoreScopeProps<T> = {
    scope: StoreScope<T>;
    store?: Store<T>;
    children?: ReactNode;
};
export declare const contextMap: WeakMap<StoreScope<any>, Context<Store<any>>>;
export declare function getStoreScopeContext<T>(scope: StoreScope<T>): Context<Store<T>>;
export declare function StoreScopeProvider<T>({ scope, store: inputStore, children }: StoreScopeProps<T>): JSX.Element;
export declare function useStoreScope<T>(scope: StoreScope<T>): Store<T>;
