import type { Cancel, UpdateFrom, Use, UseFetch } from '@core/commonTypes';
import type { MaybePromise } from './maybePromise';
export declare class CalculationHelper<T> {
    private options;
    private current?;
    constructor(options: {
        calculate: (fns: {
            use: Use;
            useFetch: UseFetch;
            updateValue: (update: UpdateFrom<MaybePromise<T>, [T | undefined]>) => void;
            updateError: (error: unknown) => void;
        }) => Cancel | void;
        addEffect: (effect: () => Cancel | void) => Cancel;
        getValue: () => T | undefined;
        setValue?: (value: T) => void;
        setError?: (error: unknown) => void;
        onInvalidate?: () => void;
    });
    execute(): void;
    stop(): void;
    check(): void;
}
