import type { Update } from '../core/commonTypes';
type FilterKey<T> = T extends string | number ? T : never;
type FilterString<T> = T extends string ? T : never;
export type Obj = Record<string | number, unknown>;
export type Arr = readonly unknown[];
type GetKeys<T> = T extends Arr ? T extends readonly [] ? never : '0' extends keyof T ? keyof T & `${number}` : number : keyof T;
export type Path<T> = 0 extends 1 & T ? string : T extends never ? never : T extends Obj | Arr ? FilterString<keyof {
    [K in FilterKey<GetKeys<T>> as `${K}` | (T[K] extends Obj | Arr | undefined | null ? `${K}.${Path<NonNullable<T[K]>>}` : never)]: 0;
}> : never;
export type Value<T, P extends string> = P extends `${infer K}.${infer Rest}` ? T[K & keyof T] extends Obj | Arr ? Value<T[K & keyof T], Rest> : T[K & keyof T] extends Obj | Arr | undefined | null ? Value<NonNullable<T[K & keyof T]>, Rest> | undefined : never : T[P & keyof T];
export declare function get<T, P extends Path<T>>(obj: T, path: P): Value<T, P>;
export declare function set<T, P extends Path<T>>(obj: T, path: P, value: Update<Value<T, P>>, rootPath?: P): T;
export {};
