import type { Store } from '../core/store';
export declare const arrayActions: {
    splice: <V>(this: Store<V[]>, start: number, deleteCount: number, ...items: V[]) => V[];
    push: <V_1>(this: Store<V_1[]>, ...args: V_1[]) => number;
    pop: <V_2>(this: Store<V_2[]>) => V_2 | undefined;
    shift: <V_3>(this: Store<V_3[]>) => V_3 | undefined;
    unshift: <V_4>(this: Store<V_4[]>, ...args: V_4[]) => number;
    reverse: <V_5>(this: Store<V_5[]>) => V_5[];
    sort: <V_6>(this: Store<V_6[]>, compareFn?: ((a: V_6, b: V_6) => number) | undefined) => V_6[];
};
export declare const recordActions: {
    set<K extends string | number | symbol, V>(this: Store<Record<K, V>>, key: K, value: V): Store<Record<K, V>>;
    delete<K_1 extends string | number | symbol, V_1>(this: Store<Record<K_1, V_1>>, key: K_1): void;
    clear<K_2 extends string | number | symbol, V_2>(this: Store<Record<K_2, V_2>>): void;
};
export declare const mapActions: {
    set<K, V>(this: Store<Map<K, V>>, key: K, value: V): Store<Map<K, V>>;
    delete<K_1, V_1>(this: Store<Map<K_1, V_1>>, key: K_1): boolean;
    clear<K_2, V_2>(this: Store<Map<K_2, V_2>>): void;
};
export declare const setActions: {
    add<T>(this: Store<Set<T>>, value: T): void;
    delete<T_1>(this: Store<Set<T_1>>, value: T_1): void;
    clear<T_2>(this: Store<Set<T_2>>): void;
};
